package cli

import (
	"fmt"
	"io"
)

// Help shows the command line argument usage.
func Help(w io.Writer, code int) int {
	fmt.Fprintln(w, `Usage:

    q [command] [options]

Commands:

    build [directory | file]       build an executable from a file or directory
        --arch [arch]                  cross-compile for another CPU architecture [x86|arm|riscv]
        --assembly, -a                 show assembly instructions
        --dry, -d                      skip writing the executable to disk
        --os [os]                      cross-compile for another OS [linux|mac|windows]
        --statistics, -s               show statistics
        --verbose, -v                  show everything

    run [directory | file]         build and run the executable
    system                         show system information
    help                           show this help`)
	return code
}
