package eval

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/cpu"
	"git.urbach.dev/cli/q/src/types"
)

// Value combines a register with its data type.
type Value struct {
	Type     types.Type
	Label    string
	Number   int
	Memory   asm.Memory
	Register cpu.Register
	Alive    uint8
	Kind     Kind
}

// IsAlive returns true if the Value is still alive.
func (v *Value) IsAlive() bool {
	return v.Alive > 0
}

// Use reduces the lifetime counter by one.
func (v *Value) Use() {
	if v.Alive == 0 {
		panic("incorrect number of value use calls")
	}

	v.Alive--
}
